From dc975affd9ef56da03580da432687e6fc7eed2af Mon Sep 17 00:00:00 2001
From: Aurélien Bompard <aurelien@bompard.org>
Date: Feb 09 2017 15:58:10 +0000
Subject: [PATCH 725/1001] Convert the memberships widget


---

diff --git a/hubs/widgets/memberships/__init__.py b/hubs/widgets/memberships/__init__.py
new file mode 100644
index 0000000..cc8f602
--- /dev/null
+++ b/hubs/widgets/memberships/__init__.py
@@ -0,0 +1,45 @@
+from __future__ import unicode_literals
+
+import hubs.models
+
+from hubs.widgets.chrome import panel
+from hubs.widgets.base import Widget, WidgetView
+
+
+ELLIPSIS_LIMIT = 3
+
+
+class Memberships(Widget):
+
+    name = "memberships"
+    position = "both"
+
+
+class BaseView(WidgetView):
+
+    name = "root"
+    url_rules = ["/"]
+    template_name = "templates/memberships.html"
+    chrome = panel('Hubs')
+
+    def get_context(self, instance, *args, **kwargs):
+        hub = instance.hub
+        members = []
+        if hub.user_hub:
+            user = hubs.models.User.by_username(hub.name)
+            members = [m.__json__() for m in user.memberships
+                       if m.name != user.username]
+        else:
+            members_name = []
+            for member in hub.members:
+                if member.username in members_name:
+                    continue
+                members_name.append(member.username)
+                members.append(member.__json__())
+
+        oldest_members = sorted(
+            members, key=lambda m: m.get('created_on'))[:ELLIPSIS_LIMIT]
+        return dict(
+            memberships=list(members),
+            oldest_members=list(oldest_members),
+            )

